Index: codes/icosagcm/trunk/src/parallel/transfert_mpi.f90
===================================================================
--- codes/icosagcm/trunk/src/parallel/transfert_mpi.f90	(revision 926)
+++ codes/icosagcm/trunk/src/parallel/transfert_mpi.f90	(revision 953)
@@ -5,6 +5,6 @@
   
   TYPE array
-    INTEGER,POINTER :: value(:)
-    INTEGER,POINTER :: sign(:)
+    INTEGER,POINTER :: value(:)=>null()
+    INTEGER,POINTER :: sign(:)=>null()
     INTEGER         :: domain
     INTEGER         :: rank
@@ -13,7 +13,7 @@
     INTEGER         :: offset
     INTEGER         :: ireq
-    INTEGER,POINTER :: buffer(:)
-    REAL,POINTER    :: buffer_r(:)
-    INTEGER,POINTER :: src_value(:)
+    INTEGER,POINTER :: buffer(:)=>null()
+    REAL,POINTER    :: buffer_r(:)=>null()
+    INTEGER,POINTER :: src_value(:)=>null()
   END TYPE array
   
@@ -77,4 +77,5 @@
     LOGICAL :: open      ! for debug
     INTEGER :: number
+    LOGICAL :: ondevice=.false. !<Ready to transfer ondevice field
   END TYPE t_message
 
@@ -942,4 +943,7 @@
 !$OMP BARRIER
 !$OMP MASTER
+    !init off-device
+    message%ondevice=.false.
+
     IF(PRESENT(name)) THEN
        message%name = TRIM(name)
@@ -1058,5 +1062,5 @@
     TYPE(t_message) :: message
 
-    INTEGER :: ireq
+    INTEGER :: ireq, ibuff
 
 !$OMP BARRIER
@@ -1084,7 +1088,31 @@
         ENDDO
 
-      ENDIF      
+      ENDIF
     ENDIF
-    
+
+    !deallocate device data if ondevice
+    if(message%ondevice) then
+      do ireq=1, ndomain
+        do ibuff=1,message%request(ireq)%nsend
+          !$acc exit data delete(message%request(ireq)%send(ibuff)%buffer(:))
+          !$acc exit data delete(message%request(ireq)%send(ibuff)%buffer_r(:))
+          !$acc exit data delete(message%request(ireq)%send(ibuff)%sign(:))
+          !$acc exit data delete(message%request(ireq)%send(ibuff)%src_value(:))
+          !$acc exit data delete(message%request(ireq)%send(ibuff)%value(:))
+        end do
+        do ibuff=1,message%request(ireq)%nrecv
+          !$acc exit data delete(message%request(ireq)%recv(ibuff)%buffer(:))
+          !$acc exit data delete(message%request(ireq)%recv(ibuff)%buffer_r(:))
+          !$acc exit data delete(message%request(ireq)%recv(ibuff)%sign(:))
+          !$acc exit data delete(message%request(ireq)%recv(ibuff)%src_value(:))
+          !$acc exit data delete(message%request(ireq)%recv(ibuff)%value(:))
+        end do
+      end do
+      DO ireq=1,message%nreq
+        !$acc exit data delete(message%buffers(ireq)%r)
+      ENDDO
+      message%ondevice=.false.
+    end if
+
     DEALLOCATE(message%mpi_req)
     DEALLOCATE(message%buffers)
@@ -1120,4 +1148,39 @@
 
 
+  !!!Update buffers on device for 'message'
+  !!! does create_device_message when not already ondevice
+  SUBROUTINE update_device_message_mpi(message)
+    USE domain_mod
+    IMPLICIT NONE
+    TYPE(t_message), intent(inout) :: message
+    INTEGER :: ireq, ibuff
+
+    !if(.not. message%ondevice) call create_device_message_mpi(message)
+
+    do ireq=1, ndomain
+      do ibuff=1,message%request(ireq)%nsend
+        !device buffers updated even if pointers not attached :
+        !non allocated buffers in 'message' must be set to NULL()
+        !$acc enter data copyin(message%request(ireq)%send(ibuff)%buffer(:)) async
+        !$acc enter data copyin(message%request(ireq)%send(ibuff)%buffer_r(:)) async
+        !$acc enter data copyin(message%request(ireq)%send(ibuff)%sign(:)) async
+        !$acc enter data copyin(message%request(ireq)%send(ibuff)%src_value(:)) async
+        !$acc enter data copyin(message%request(ireq)%send(ibuff)%value(:)) async
+      end do
+      do ibuff=1,message%request(ireq)%nrecv
+        !$acc enter data copyin(message%request(ireq)%recv(ibuff)%buffer(:)) async
+        !$acc enter data copyin(message%request(ireq)%recv(ibuff)%buffer_r(:)) async
+        !$acc enter data copyin(message%request(ireq)%recv(ibuff)%sign(:)) async
+        !$acc enter data copyin(message%request(ireq)%recv(ibuff)%src_value(:)) async
+        !$acc enter data copyin(message%request(ireq)%recv(ibuff)%value(:)) async
+      end do
+    end do
+    DO ireq=1,message%nreq
+      !$acc enter data copyin(message%buffers(ireq)%r) async
+    ENDDO
+    message%ondevice=.true.
+  END SUBROUTINE
+
+  !TODO : add openacc with multiple process
   SUBROUTINE send_message_mpi(field,message)
   USE abort_mod
@@ -1129,4 +1192,5 @@
   USE omp_para
   USE trace
+  USE abort_mod
   IMPLICIT NONE
     TYPE(t_field),POINTER :: field(:)
@@ -1145,5 +1209,5 @@
     INTEGER :: dim3,dim4,d3,d4
     INTEGER,POINTER :: src_value(:)
-    INTEGER :: offset,msize,rank
+    INTEGER :: offset,msize,moffset,rank
     INTEGER :: lbegin, lend
     INTEGER :: max_req
@@ -1152,4 +1216,7 @@
 
     CALL enter_profile(id_mpi)
+
+    !Prepare 'message' for on-device copies if field is on device
+    if( field(1)%ondevice .AND. .NOT. message%ondevice ) call update_device_message_mpi(message)
 
 !$OMP BARRIER
@@ -1195,10 +1262,12 @@
               buffer_r=>message%buffers(ireq)%r
               offset=send%offset
-                                            
-              DO n=1,send%size
+              msize=send%size
+              !$acc parallel loop default(present) async if (field(ind)%ondevice)
+              DO n=1,msize
                 buffer_r(offset+n)=rval2d(value(n))
               ENDDO
 
               IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
+                CALL abort_acc("mpi_threading_mode==MPI_THREAD_SERIALIZED")
                 !$OMP CRITICAL            
                 CALL MPI_ISEND(buffer_r,send%size,MPI_REAL8,send%rank,               &
@@ -1206,4 +1275,5 @@
                 !$OMP END CRITICAL
               ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
+                CALL abort_acc("mpi_threading_mode==MPI_THREAD_MULTIPLE")
                 CALL MPI_ISEND(buffer_r,send%size,MPI_REAL8,send%rank,               &
                   send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
@@ -1228,6 +1298,7 @@
               src_rval2d=>field(recv%domain)%rval2d
               sgn=>recv%sign
-
-              DO n=1,recv%size
+              msize=recv%size
+              !$acc parallel loop default(present) async if (field(ind)%ondevice)
+              DO n=1,msize
                 rval2d(value(n))=src_rval2d(src_value(n))*sgn(n)
               ENDDO
@@ -1239,4 +1310,5 @@
               buffer_r=>message%buffers(ireq)%r
               IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
+                CALL abort_acc("mpi_threading_mode==MPI_THREAD_SERIALIZED")
                !$OMP CRITICAL            
                 CALL MPI_IRECV(buffer_r,recv%size,MPI_REAL8,recv%rank,               &
@@ -1244,4 +1316,5 @@
                !$OMP END CRITICAL
               ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
+                 CALL abort_acc("mpi_threading_mode==MPI_THREAD_MULTIPLE")
                  CALL MPI_IRECV(buffer_r,recv%size,MPI_REAL8,recv%rank,              &
                    recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
@@ -1278,13 +1351,15 @@
               buffer_r=>message%buffers(ireq)%r
 
-              offset=send%offset*dim3 + (lbegin-1)*send%size
-          
+              msize=send%size
+              moffset=send%offset
               CALL trace_start("copy_to_buffer")
 
+              !$acc parallel loop default(present) async if (field(ind)%ondevice)
               DO d3=lbegin,lend
-                DO n=1,send%size
+                offset=moffset*dim3 + (d3-1)*msize
+                !$acc loop
+                DO n=1,msize
                   buffer_r(n+offset)=rval3d(value(n),d3)
                 ENDDO
-                offset=offset+send%size
               ENDDO
               CALL trace_end("copy_to_buffer")
@@ -1296,4 +1371,5 @@
               IF (is_omp_level_master) THEN
                 IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
+                  CALL abort_acc("mpi_threading_mode==MPI_THREAD_SERIALIZED")
                   !$OMP CRITICAL   
                   CALL MPI_ISEND(buffer_r,send%size*dim3,MPI_REAL8,send%rank,        &
@@ -1301,4 +1377,5 @@
                   !$OMP END CRITICAL
                 ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
+                  CALL abort_acc("mpi_threading_mode==MPI_THREAD_MULTIPLE")
                   CALL MPI_ISEND(buffer_r,send%size*dim3,MPI_REAL8,send%rank,        &
                     send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
@@ -1335,9 +1412,10 @@
               src_rval3d=>field(recv%domain)%rval3d
               sgn=>recv%sign
+              msize=recv%size
 
               CALL trace_start("copy_data")
-
+              !$acc parallel loop collapse(2) default(present) async if (field(ind)%ondevice)
               DO d3=lbegin,lend
-                DO n=1,recv%size
+                DO n=1,msize
                   rval3d(value(n),d3)=src_rval3d(src_value(n),d3)*sgn(n)
                 ENDDO
@@ -1351,4 +1429,5 @@
               IF (is_omp_level_master) THEN
                 IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
+                  CALL abort_acc("mpi_threading_mode==MPI_THREAD_SERIALIZED")
                   !$OMP CRITICAL
                   CALL MPI_IRECV(buffer_r,recv%size*dim3,MPI_REAL8,recv%rank,        &
@@ -1356,4 +1435,5 @@
                   !$OMP END CRITICAL
                 ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
+                  CALL abort_acc("mpi_threading_mode==MPI_THREAD_MULTIPLE")
                   CALL MPI_IRECV(buffer_r,recv%size*dim3,MPI_REAL8,recv%rank,        &
                     recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
@@ -1390,15 +1470,17 @@
               ireq=send%ireq
               buffer_r=>message%buffers(ireq)%r
+              msize=send%size
+              moffset=send%offset
 
               CALL trace_start("copy_to_buffer")
+              !$acc parallel loop default(present) collapse(2) async if (field(ind)%ondevice)
               DO d4=1,dim4
-                offset=send%offset*dim3*dim4 + dim3*send%size*(d4-1) +               &
-                  (lbegin-1)*send%size
-
                 DO d3=lbegin,lend
-                  DO n=1,send%size
+                  offset=moffset*dim3*dim4 + dim3*msize*(d4-1) +               &
+                    (d3-1)*msize
+                  !$acc loop
+                  DO n=1,msize
                     buffer_r(n+offset)=rval4d(value(n),d3,d4)
                   ENDDO
-                  offset=offset+send%size
                 ENDDO
               ENDDO
@@ -1411,4 +1493,5 @@
               IF (is_omp_level_master) THEN
                 IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
+                  CALL abort_acc("mpi_threading_mode==MPI_THREAD_SERIALIZED")
                   !$OMP CRITICAL
                   CALL MPI_ISEND(buffer_r,send%size*dim3*dim4,MPI_REAL8,send%rank,   &
@@ -1416,4 +1499,5 @@
                   !$OMP END CRITICAL
                 ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
+                  CALL abort_acc("mpi_threading_mode==MPI_THREAD_MULTIPLE")
                   CALL MPI_ISEND(buffer_r,send%size*dim3*dim4,MPI_REAL8,send%rank,   &
                     send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
@@ -1451,9 +1535,11 @@
               src_rval4d=>field(recv%domain)%rval4d
               sgn=>recv%sign
-
+              msize=recv%size
               CALL trace_start("copy_data")
+
+              !$acc parallel loop collapse(3) default(present) async if (field(ind)%ondevice)
               DO d4=1,dim4
                 DO d3=lbegin,lend
-                  DO n=1,recv%size
+                  DO n=1,msize
                     rval4d(value(n),d3,d4)=src_rval4d(src_value(n),d3,d4)*sgn(n)
                   ENDDO
@@ -1469,4 +1555,5 @@
               IF (is_omp_level_master) THEN
                 IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
+                  CALL abort_acc("mpi_threading_mode==MPI_THREAD_SERIALIZED")
                  !$OMP CRITICAL           
                   CALL MPI_IRECV(buffer_r,recv%size*dim3*dim4,MPI_REAL8,recv%rank,   &
@@ -1474,4 +1561,5 @@
                   !$OMP END CRITICAL
                 ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
+                  CALL abort_acc("mpi_threading_mode==MPI_THREAD_MULTIPLE")
                   CALL MPI_IRECV(buffer_r,recv%size*dim3*dim4,MPI_REAL8,recv%rank,   &
                     recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr) 
@@ -1485,4 +1573,5 @@
 
       IF (mpi_threading_mode==MPI_THREAD_FUNNELED .OR. mpi_threading_mode==MPI_THREAD_SINGLE) THEN
+!$acc wait
 !$OMP BARRIER
 !$OMP MASTER        
@@ -1492,6 +1581,14 @@
           msize=message%buffers(ireq)%size
           rank=message%buffers(ireq)%rank
-          CALL MPI_ISEND(buffer_r,msize,MPI_REAL8,rank,1000*message%number,          &
-            comm_icosa, message%mpi_req(ireq),ierr)
+          ! Using the "if" clause on the "host_data" directive seems to cause a crash at compilation
+          IF (message%ondevice) THEN
+            !$acc host_data use_device(buffer_r) ! if (message%ondevice)
+            CALL MPI_ISEND(buffer_r,msize,MPI_REAL8,rank,1000*message%number,          &
+              comm_icosa, message%mpi_req(ireq),ierr)
+            !$acc end host_data
+          ELSE
+            CALL MPI_ISEND(buffer_r,msize,MPI_REAL8,rank,1000*message%number,          &
+              comm_icosa, message%mpi_req(ireq),ierr)
+          ENDIF
         ENDDO
 
@@ -1500,6 +1597,14 @@
           msize=message%buffers(ireq)%size
           rank=message%buffers(ireq)%rank
-          CALL MPI_IRECV(buffer_r,msize,MPI_REAL8,rank,1000*message%number,          &
-            comm_icosa, message%mpi_req(ireq),ierr)
+          ! Using the "if" clause on the "host_data" directive seems to cause a crash at compilation
+          IF (message%ondevice) THEN
+            !$acc host_data use_device(buffer_r) ! if (message%ondevice)
+            CALL MPI_IRECV(buffer_r,msize,MPI_REAL8,rank,1000*message%number,          &
+              comm_icosa, message%mpi_req(ireq),ierr)
+            !$acc end host_data
+          ELSE
+            CALL MPI_IRECV(buffer_r,msize,MPI_REAL8,rank,1000*message%number,          &
+              comm_icosa, message%mpi_req(ireq),ierr)
+          ENDIF
         ENDDO
 
@@ -1552,5 +1657,5 @@
     INTEGER :: ind,n
     INTEGER :: dim3,dim4,d3,d4,lbegin,lend
-    INTEGER :: offset
+    INTEGER :: offset, msize, moffset
 
     message%open=.FALSE.
@@ -1586,5 +1691,7 @@
               sgn=>recv%sign
               offset=recv%offset
-              DO n=1,recv%size
+              msize=recv%size
+              !$acc parallel loop default(present) async if (field(ind)%ondevice)
+              DO n=1,msize
                 rval2d(value(n))=buffer_r(n+offset)*sgn(n)  
               ENDDO
@@ -1621,20 +1728,25 @@
     
               CALL distrib_level(1,dim3, lbegin,lend)
-              offset=recv%offset*dim3 + (lbegin-1)*recv%size
+              msize=recv%size
+              moffset=recv%offset
               CALL trace_start("copy_from_buffer")
               
               IF (req%vector) THEN
+                !$acc parallel loop default(present) async if (field(ind)%ondevice)
                 DO d3=lbegin,lend
-                  DO n=1,recv%size
+                  offset=moffset*dim3 + (d3-1)*msize
+                  !$acc loop
+                  DO n=1,msize
                     rval3d(value(n),d3)=buffer_r(n+offset)*sgn(n)  
                   ENDDO
-                  offset=offset+recv%size
                 ENDDO
               ELSE
+                !$acc parallel loop default(present) async if (field(ind)%ondevice)
                 DO d3=lbegin,lend
-                  DO n=1,recv%size
+                  offset=moffset*dim3 + (d3-1)*msize
+                  !$acc loop
+                  DO n=1,msize
                     rval3d(value(n),d3)=buffer_r(n+offset)  
                   ENDDO
-                  offset=offset+recv%size
                 ENDDO
               ENDIF
@@ -1670,13 +1782,16 @@
               CALL distrib_level(1,dim3, lbegin,lend)
               dim4=size(rval4d,3)
+              msize=recv%size
+              moffset=recv%offset
               CALL trace_start("copy_from_buffer")
+              !$acc parallel loop default(present) collapse(2) async if (field(ind)%ondevice)
               DO d4=1,dim4
-                offset=recv%offset*dim3*dim4 + dim3*recv%size*(d4-1) +               &
-                  (lbegin-1)*recv%size
                 DO d3=lbegin,lend
-                  DO n=1,recv%size
+                  offset=moffset*dim3*dim4 + dim3*msize*(d4-1) +               &
+                    (d3-1)*msize
+                  !$acc loop
+                  DO n=1,msize
                     rval4d(value(n),d3,d4)=buffer_r(n+offset)*sgn(n) 
                   ENDDO
-                  offset=offset+recv%size
                 ENDDO
               ENDDO
@@ -1697,5 +1812,5 @@
 !    CALL trace_end("wait_message_mpi")
 !$OMP BARRIER
-    
+  
     CALL exit_profile(id_mpi)
 
Index: codes/icosagcm/trunk/src/physics/physics.f90
===================================================================
--- codes/icosagcm/trunk/src/physics/physics.f90	(revision 926)
+++ codes/icosagcm/trunk/src/physics/physics.f90	(revision 953)
@@ -27,4 +27,5 @@
   SUBROUTINE init_physics
     USE mpipara
+    USE abort_mod
     USE etat0_mod
     USE physics_dcmip_mod, ONLY : init_physics_dcmip=>init_physics
@@ -118,7 +119,11 @@
     
 !$OMP END PARALLEL
+    IF (phys_type /= phys_none) THEN
+       CALL abort_acc("physics /= 'none'")
+    END IF
   END SUBROUTINE init_physics
 
   SUBROUTINE zero_du_phys()
+    USE abort_mod
     REAL(rstd), DIMENSION(:,:), POINTER :: du
     INTEGER :: ind
@@ -154,4 +159,5 @@
     USE etat0_heldsz_mod
     USE etat0_venus_mod, ONLY : phys_venus => physics
+    USE abort_mod
     INTEGER, INTENT(IN)   :: it
     TYPE(t_field),POINTER :: f_phis(:)
Index: codes/icosagcm/trunk/src/sphere/geometry.f90
===================================================================
--- codes/icosagcm/trunk/src/sphere/geometry.f90	(revision 926)
+++ codes/icosagcm/trunk/src/sphere/geometry.f90	(revision 953)
@@ -266,6 +266,5 @@
     INTEGER :: nb_it=0
     TYPE(t_domain),POINTER :: d
-    INTEGER :: ind,it,i,j,n,k
-    REAL(rstd) :: x1(3),x2(3)
+    INTEGER :: ind,it,i,j,n
     REAL(rstd) :: vect(3,6)
     REAL(rstd) :: centr(3)
@@ -690,4 +689,36 @@
 !    CALL surf_triangle(d%xyz(:,ii_begin,jj_begin),d%xyz(:,ii_begin,jj_end),d%xyz(:,ii_end,jj_begin),S)
  
+    CALL update_device_field(geom%Ai)
+
+    CALL update_device_field(geom%xyz_i)
+    CALL update_device_field(geom%lon_i)
+    CALL update_device_field(geom%lat_i)
+    CALL update_device_field(geom%elon_i)
+    CALL update_device_field(geom%elat_i)
+    CALL update_device_field(geom%centroid)
+
+    CALL update_device_field(geom%xyz_e)
+    CALL update_device_field(geom%lon_e)
+    CALL update_device_field(geom%lat_e)
+    CALL update_device_field(geom%elon_e)
+    CALL update_device_field(geom%elat_e)
+    CALL update_device_field(geom%ep_e)
+    CALL update_device_field(geom%et_e)
+
+    CALL update_device_field(geom%xyz_v)
+    CALL update_device_field(geom%de)
+    CALL update_device_field(geom%le)
+    CALL update_device_field(geom%le_de)
+    CALL update_device_field(geom%bi)
+    CALL update_device_field(geom%Av)
+    CALL update_device_field(geom%S1)
+    CALL update_device_field(geom%S2)
+    CALL update_device_field(geom%Riv)
+    CALL update_device_field(geom%Riv2)
+    CALL update_device_field(geom%ne)
+    CALL update_device_field(geom%Wee)
+    CALL update_device_field(geom%bi)
+    CALL update_device_field(geom%fv)
+
   END SUBROUTINE set_geometry
   
Index: codes/icosagcm/trunk/src/time/euler_scheme.F90
===================================================================
--- codes/icosagcm/trunk/src/time/euler_scheme.F90	(revision 953)
+++ codes/icosagcm/trunk/src/time/euler_scheme.F90	(revision 953)
@@ -0,0 +1,253 @@
+MODULE euler_scheme_mod
+  USE field_mod
+  USE abort_mod
+  IMPLICIT NONE
+  PRIVATE
+
+  TYPE(t_field),POINTER,SAVE,PUBLIC :: f_geopot(:), f_q(:), &
+       f_rhodz(:), f_mass(:), f_massm1(:), f_massm2(:), f_dmass(:), & ! current and previous time steps + tendency of mass,
+       f_phis(:), f_ps(:),f_psm1(:), f_psm2(:), f_dps(:), &           ! column-integrated mass
+       f_u(:),f_um1(:),f_um2(:), f_du(:), f_W(:), &                   ! 'horizontal' and vertical (NH) momentum
+       f_theta_rhodz(:),f_theta_rhodzm1(:),f_theta_rhodzm2(:), f_dtheta_rhodz(:), & ! mass-weighted theta/entropy
+       f_hflux(:), f_wflux(:), f_hfluxt(:), f_wfluxt(:), &            ! accumulated mass fluxes
+       f_du_slow(:,:), f_du_fast(:,:), &                              ! slow/fast trend arrays 
+       f_dmass_slow(:,:), f_dps_slow(:,:), f_dtheta_rhodz_slow(:,:), &! for HEVI time scheme 
+       f_dPhi_slow(:,:), f_dPhi_fast(:,:), &                          ! geopotential tendencies (NH)
+       f_dW_slow(:,:), f_dW_fast(:,:)                                 ! vertical momentum tendencies (NH)
+
+  INTEGER, PARAMETER, PUBLIC :: explicit=1, hevi=2, euler=1, rk4=2, mlf=3, rk25=4, ark23=6, ark33=7
+
+  INTEGER,SAVE, PUBLIC :: nb_stage, matsuno_period, scheme, scheme_family
+  !$OMP THREADPRIVATE(nb_stage, matsuno_period, scheme, scheme_family)
+
+  PUBLIC :: euler_scheme, accumulate_fluxes, legacy_to_DEC, DEC_to_legacy
+CONTAINS
+
+  SUBROUTINE Euler_scheme(with_dps,fluxt_zero)
+    USE icosa
+    USE disvert_mod
+    USE omp_para
+    USE trace
+    LOGICAL :: with_dps
+    LOGICAL, OPTIONAL :: fluxt_zero(ndomain) ! set to .TRUE. to start accumulating fluxes in time
+    REAL(rstd),POINTER :: ps(:), dps(:)
+    REAL(rstd),POINTER :: u(:,:) , du(:,:)
+    REAL(rstd),POINTER :: mass(:,:), dmass(:,:)
+    REAL(rstd),POINTER :: theta_rhodz(:,:,:), dtheta_rhodz(:,:,:)
+    REAL(rstd),POINTER :: hflux(:,:),wflux(:,:),hfluxt(:,:),wfluxt(:,:)
+    INTEGER :: ind
+    INTEGER :: ij,l
+    CALL trace_start("Euler_scheme")  
+
+    DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
+       CALL swap_dimensions(ind)
+       CALL swap_geometry(ind)
+
+       IF(with_dps) THEN ! update ps/mass
+          CALL abort_acc("Euler_scheme/with_dps")
+          IF(caldyn_eta==eta_mass) THEN ! update ps
+             ps=f_ps(ind) ; dps=f_dps(ind) ;              
+             IF (is_omp_first_level) THEN
+                !DIR$ SIMD
+                DO ij=ij_begin,ij_end
+                   ps(ij)=ps(ij)+dt*dps(ij)
+                ENDDO
+             ENDIF
+          ELSE ! update mass
+             mass=f_mass(ind) ; dmass=f_dmass(ind) ;              
+             DO l=ll_begin,ll_end
+                !DIR$ SIMD
+                DO ij=ij_begin,ij_end
+                   mass(ij,l)=mass(ij,l)+dt*dmass(ij,l)
+                ENDDO
+             END DO
+          END IF
+
+          hflux=f_hflux(ind);     hfluxt=f_hfluxt(ind)
+          wflux=f_wflux(ind);     wfluxt=f_wfluxt(ind)
+          CALL accumulate_fluxes(hflux,wflux,hfluxt,wfluxt,dt,fluxt_zero(ind))
+       END IF ! update ps/mass
+
+       u=f_u(ind) ; theta_rhodz=f_theta_rhodz(ind)
+       du=f_du(ind) ; dtheta_rhodz=f_dtheta_rhodz(ind)
+
+       CALL compute_euler_scheme(u, du, theta_rhodz, dtheta_rhodz)
+    ENDDO
+
+    CALL trace_end("Euler_scheme")
+
+    CONTAINS
+
+    SUBROUTINE compute_euler_scheme(u, du, theta_rhodz, dtheta_rhodz)
+       REAL(rstd),INTENT(INOUT) :: u(iim*3*jjm,llm)
+       REAL(rstd),INTENT(IN)    :: du(iim*3*jjm,llm)
+       REAL(rstd),INTENT(INOUT) :: theta_rhodz(iim*jjm,llm,nqdyn)
+       REAL(rstd),INTENT(IN)    :: dtheta_rhodz(iim*jjm,llm,nqdyn)
+
+       !$acc data present(theta_rhodz(:,:,:), u(:,:),du(:,:), dtheta_rhodz(:,:,:)) async
+
+       !$acc parallel loop async
+       DO l=ll_begin,ll_end
+          !$acc loop
+          !DIR$ SIMD
+          DO ij=ij_begin,ij_end
+             u(ij+u_right,l)=u(ij+u_right,l)+dt*du(ij+u_right,l)
+             u(ij+u_lup,l)=u(ij+u_lup,l)+dt*du(ij+u_lup,l)
+             u(ij+u_ldown,l)=u(ij+u_ldown,l)+dt*du(ij+u_ldown,l)
+             theta_rhodz(ij,l,1)=theta_rhodz(ij,l,1)+dt*dtheta_rhodz(ij,l,1)
+          ENDDO
+       ENDDO
+       
+       !$acc end data
+    END SUBROUTINE compute_euler_scheme
+
+  END SUBROUTINE Euler_scheme
+
+  SUBROUTINE accumulate_fluxes(hflux,wflux, hfluxt,wfluxt, tau,fluxt_zero)
+    USE dimensions
+    USE omp_para
+    USE disvert_mod
+    IMPLICIT NONE
+    REAL(rstd), INTENT(IN)    :: hflux(3*iim*jjm,llm), wflux(iim*jjm,llm+1)
+    REAL(rstd), INTENT(INOUT) :: hfluxt(3*iim*jjm,llm), wfluxt(iim*jjm,llm+1)
+    REAL(rstd), INTENT(IN) :: tau
+    LOGICAL, INTENT(INOUT) :: fluxt_zero
+    INTEGER :: l,ij
+
+    !$acc data present(hflux(:,:), wflux(:,:), hfluxt(:,:), wfluxt(:,:)) async
+
+    IF(fluxt_zero) THEN
+
+       fluxt_zero=.FALSE.
+       !$acc parallel loop async
+       DO l=ll_begin,ll_end
+          !$acc loop
+          !DIR$ SIMD
+          DO ij=ij_begin_ext,ij_end_ext
+             hfluxt(ij+u_right,l) = tau*hflux(ij+u_right,l)
+             hfluxt(ij+u_lup,l) = tau*hflux(ij+u_lup,l)
+             hfluxt(ij+u_ldown,l) = tau*hflux(ij+u_ldown,l)
+          ENDDO
+       ENDDO
+
+       IF(caldyn_eta==eta_mass) THEN ! no need for vertical fluxes if eta_lag
+          !$acc parallel loop async
+          DO l=ll_begin,ll_endp1
+             !$acc loop
+             !DIR$ SIMD
+             DO ij=ij_begin,ij_end
+                wfluxt(ij,l) = tau*wflux(ij,l)
+             ENDDO
+          ENDDO
+       END IF
+
+    ELSE
+       !$acc parallel loop async
+       DO l=ll_begin,ll_end
+          !$acc loop
+          !DIR$ SIMD
+          DO ij=ij_begin_ext,ij_end_ext
+             hfluxt(ij+u_right,l) = hfluxt(ij+u_right,l)+tau*hflux(ij+u_right,l)
+             hfluxt(ij+u_lup,l) = hfluxt(ij+u_lup,l)+tau*hflux(ij+u_lup,l)
+             hfluxt(ij+u_ldown,l) = hfluxt(ij+u_ldown,l)+tau*hflux(ij+u_ldown,l)
+          ENDDO
+       ENDDO
+
+       IF(caldyn_eta==eta_mass) THEN ! no need for vertical fluxes if eta_lag
+          !$acc parallel loop async
+          DO l=ll_begin,ll_endp1
+             !$acc loop
+             !DIR$ SIMD
+             DO ij=ij_begin,ij_end
+                wfluxt(ij,l) = wfluxt(ij,l)+tau*wflux(ij,l)
+             ENDDO
+          ENDDO
+       END IF
+    END IF
+    !$acc end data
+  END SUBROUTINE accumulate_fluxes
+
+  SUBROUTINE legacy_to_DEC(f_ps, f_u)
+    USE icosa
+    USE disvert_mod
+    USE omp_para
+    USE trace
+    TYPE(t_field),POINTER :: f_ps(:), f_u(:)
+    REAL(rstd), POINTER :: ps(:), u(:,:)
+    INTEGER :: ind,ij,l
+
+    CALL trace_start("legacy_to_DEC")
+
+    DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
+       CALL swap_dimensions(ind)
+       CALL swap_geometry(ind)
+
+       IF(caldyn_eta==eta_mass .AND. is_omp_first_level) THEN ! update ps
+          ps=f_ps(ind)
+          !$acc parallel loop async default(present)
+          !DIR$ SIMD
+          DO ij=ij_begin,ij_end
+             ps(ij)=(ps(ij)-ptop)/g ! convert ps to column-integrated mass
+          ENDDO
+       END IF
+
+       u=f_u(ind)
+       !$acc parallel loop async default(present)
+       DO l=ll_begin,ll_end
+          !$acc loop
+          !DIR$ SIMD
+          DO ij=ij_begin,ij_end
+             u(ij+u_right,l)=u(ij+u_right,l)*de(ij+u_right)
+             u(ij+u_lup,l)=u(ij+u_lup,l)*de(ij+u_lup)
+             u(ij+u_ldown,l)=u(ij+u_ldown,l)*de(ij+u_ldown)
+          ENDDO
+       ENDDO
+    ENDDO
+
+    CALL trace_end("legacy_to_DEC")  
+
+  END SUBROUTINE Legacy_to_DEC
+
+  SUBROUTINE DEC_to_legacy(f_ps, f_u)
+    USE icosa
+    USE disvert_mod
+    USE omp_para
+    USE trace
+    TYPE(t_field),POINTER :: f_ps(:), f_u(:)
+    REAL(rstd), POINTER :: ps(:), u(:,:)
+    INTEGER :: ind,ij,l
+    CALL trace_start("legacy_to_DEC")
+
+    DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
+       CALL swap_dimensions(ind)
+       CALL swap_geometry(ind)
+
+       IF(caldyn_eta==eta_mass .AND. is_omp_first_level) THEN
+          ps=f_ps(ind)
+          !$acc parallel loop async default(present)
+          !DIR$ SIMD
+          DO ij=ij_begin,ij_end
+             ps(ij)=ptop+ps(ij)*g ! convert column-integrated mass to ps
+          ENDDO
+       ENDIF
+       
+       u=f_u(ind)
+       !$acc parallel loop async default(present)
+       DO l=ll_begin,ll_end
+          !$acc loop
+          !DIR$ SIMD
+          DO ij=ij_begin,ij_end
+             u(ij+u_right,l)=u(ij+u_right,l)/de(ij+u_right)
+             u(ij+u_lup,l)=u(ij+u_lup,l)/de(ij+u_lup)
+             u(ij+u_ldown,l)=u(ij+u_ldown,l)/de(ij+u_ldown)
+          ENDDO
+       ENDDO
+    ENDDO
+
+    CALL trace_end("DEC_to_legacy")  
+  END SUBROUTINE DEC_to_legacy
+
+END MODULE euler_scheme_mod
